/*******************************************************************
                      C O P Y R I G H T  (c) 1997
        F O C U S     A U T O M A T I O N   S Y S T E M S   I N C.
                          All Rights Reserved.
 -------------------------------------------------------------------

 setup.c - Setup function for the sample text widget dialog.

 -------------------------------------------------------------------
 *******************************************************************
 * $Source: $
 * $Date: $
 * $Revision: $
 *******************************************************************
*/

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "abimport.h"
#include "proto.h"


/* This setup function adds user data for the verify functions to some
   of the widgets in the sample dialog.  The 3 numeric examples use
   the user data as a format string in realized, activate, and
   lost_focus callbacks.  The three charset examples use the user data
   in the modify_verify and realized callbacks, to limit the accepted
   characters in the field. */

int setup( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
    PtArg_t  arg;
    char     format[20];
    char     charset[80];

    widget = widget, apinfo = apinfo, cbinfo = cbinfo;

    /* First, set up the 3 numeric field examples. */

    strcpy( format, "%04d" );

    PtSetArg( &arg, Pt_ARG_USER_DATA, format, strlen( format ) + 1 );
    PtSetResources( ABW_fint_field, 1, &arg );

    strcpy( format, "%6.4f" );

    PtSetArg( &arg, Pt_ARG_USER_DATA, format, strlen( format ) + 1 );
    PtSetResources( ABW_ffloat_field, 1, &arg );

    PtSetArg( &arg, Pt_ARG_USER_DATA, format, strlen( format ) + 1 );
    PtSetResources( ABW_fufloat_field, 1, &arg );

    strcpy( format, "%02u" );

    PtSetArg( &arg, Pt_ARG_USER_DATA, format, strlen( format ) + 1 );
    PtSetResources( ABW_funsigned_field, 1, &arg );


    /* Next, the 3 charset examples. */

    strcpy( charset, "0123456789AaBbCcDdEeFf" );

    PtSetArg( &arg, Pt_ARG_USER_DATA, charset, strlen( charset ) + 1 );
    PtSetResources( ABW_charset_field, 1, &arg );

    strcpy( charset, "0123456789AaBbCcDdEeFf" );

    PtSetArg( &arg, Pt_ARG_USER_DATA, charset, strlen( charset ) + 1 );
    PtSetResources( ABW_upperset_field, 1, &arg );

    strcpy( charset, "0123456789AaBbCcDdEeFf" );

    PtSetArg( &arg, Pt_ARG_USER_DATA, charset, strlen( charset ) + 1 );
    PtSetResources( ABW_lowerset_field, 1, &arg );

    return( Pt_CONTINUE );
}

